HeartbeatSensorGui = HeartbeatSensorGui or class()

function HeartbeatSensorGui.angle_from(a,b,c,d) -- converts to angle with ranges (-180 , 180); for result range 0-360, do +180 to result
	--mvector3.angle() is a big fat meanie zucchini;
	a = a or "nil"
	b = b or "nil"
	c = c or "nil"
	d = d or "nil"
	local function do_angle(x1,y1,x2,y2)
		local angle = 0
		local x = x2 - x1 --x diff
		local y = y2 - y1 --y diff
		if x ~= 0 then 
			angle = math.atan(y / x) % 180
			if y == 0 then 
				if x > 0 then 
					angle = 180 --right
				else
					angle = 0 --left 
				end
			elseif y > 0 then 
				angle = angle - 180
			end
		else
			if y > 0 then
				angle = 270 --up
			else
				angle = 90 --down
			end
		end
		
		return angle
	end
	local vectype = type(Vector3())
	if (type(a) == vectype) and (type(b) == vectype) then  --vector pos diff
		return do_angle(a.x,a.y,b.x,b.y)
	elseif (type(a) == "number") and (type(b) == "number") and (type(c) == "number") and (type(d) == "number") then --manual x/y pos diff
		return do_angle(a,b,c,d)
	else
		--log("ERROR: angle_from(" .. table.concat({a,b,c,d},",") .. ") failed - bad/mismatched arg types")
		return 0
	end
end

function HeartbeatSensorGui:init(unit)
	self._unit = unit
	self._gui_object = self._gui_object or "g_tracker"
	self._new_gui = World:gui()
	
	self._on = false

--creation data
	self._SLOT_MASK_NAME = self._SLOT_MASK_NAME or "persons"
	self._SLOT_MASK = self._SLOT_MASK or managers.slot:get_mask(self._SLOT_MASK_NAME)
	self._USER_UNIT = self._USER_UNIT or nil


	self.SAFE_BOUNDARY_LEFT = self.SAFE_BOUNDARY_LEFT or 33
	self.SAFE_BOUNDARY_RIGHT = self.SAFE_BOUNDARY_RIGHT or 653
	self.SAFE_BOUNDARY_TOP = self.SAFE_BOUNDARY_TOP or 28
	self.SAFE_BOUNDARY_BOTTOM = self.SAFE_BOUNDARY_BOTTOM or 470

	self.PANEL_WIDTH = self.PANEL_WIDTH or 700
	self.PANEL_HEIGHT = self.PANEL_HEIGHT or 500
	self.WORLD_WIDTH = self.WORLD_WIDTH or 8
	self.WORLD_HEIGHT = self.WORLD_HEIGHT or 6
	
	self.OVERLAY_TEXTURE = self.OVERLAY_TEXTURE or "units/mods/weapons/wpn_fps_upg_gadget_heartsensor/wpn_fps_upg_gadget_heartsensor_overlay"
	self.BLIP_TEXTURE = self.BLIP_TEXTURE or "units/mods/weapons/wpn_fps_upg_gadget_heartsensor/wpn_fps_upg_gadget_heartsensor_blip"
	self.SCANLINES_TEXTURE = self.SCANLINES_TEXTURE or "units/mods/weapons/wpn_fps_upg_gadget_heartsensor/wpn_fps_upg_gadget_heartsensor_scanlines"
	self.BATTERY_FRAME_TEXTURE = self.BATTERY_FRAME_TEXTURE or "units/mods/weapons/wpn_fps_upg_gadget_heartsensor/wpn_fps_upg_gadget_heartsensor_battery_frame"
	self.BATTERY_FILL_TEXTURE = self.BATTERY_FILL_TEXTURE or "units/mods/weapons/wpn_fps_upg_gadget_heartsensor/wpn_fps_upg_gadget_heartsensor_battery_fill"
	self.PULSEWAVE_TEXTURE = self.PULSEWAVE_TEXTURE or "guis/textures/pd2/hud_radial_rim"
	
	self.BATTERY_FILL_WIDTH = self.BATTERY_FILL_WIDTH or 116
	self.BATTERY_FILL_HEIGHT = self.BATTERY_FILL_HEIGHT or 52
	self.BATTERY_FRAME_WIDTH = self.BATTERY_FRAME_WIDTH or 128
	self.BATTERY_FRAME_HEIGHT = self.BATTERY_FRAME_HEIGHT or 64
	self.BATTERY_FILL_OFFSET_X = self.BATTERY_FILL_OFFSET_X or 6
	self.BATTERY_FILL_OFFSET_Y = self.BATTERY_FILL_OFFSET_Y or 6
	self.BATTERY_X = self.BATTERY_X or (self.SAFE_BOUNDARY_RIGHT - 100)
	self.BATTERY_Y = self.BATTERY_Y or (self.SAFE_BOUNDARY_TOP + 20)
	self.BATTERY_ALPHA = self.BATTERY_ALPHA or 0.5
	self.BATTERY_SCALE = self.BATTERY_SCALE or 0.5
	self.BATTERY_FLASH_SPEED = self.BATTERY_FLASH_SPEED or 500
	self.BATTERY_EMPTY_COLOR = self.BATTERY_EMPTY_COLOR or "880000"
	self._BATTERY_EMPTY_COLOR = Color(self.BATTERY_EMPTY_COLOR)
	self.BATTERY_COLOR = self.BATTERY_COLOR or "ffffff"
	self._BATTERY_COLOR = Color(self.BATTERY_COLOR)
	
	self.SENSOR_RANGE = self.SENSOR_RANGE or 2500
	self.SENSOR_SWEEP_DURATION = self.SENSOR_SWEEP_DURATION or 1
	self.SENSOR_SWEEP_INTERVAL = self.SENSOR_SWEEP_INTERVAL or 3
	self.SENSOR_SWEEP_PERCENT = self.SENSOR_SWEEP_PERCENT or 0.05 --this is essentially responsible for the staggered appearance of blips
	self.SENSOR_SWEEP_STAGGER = 2.2 --offset of when the radar pulsewave bloom occurs
	
	self.READOUT_SCALE = self.READOUT_SCALE or 0.7 --multiplier used for determining panel distance of bitmap objects on the readout panel
	
	self.BLIP_SIZE = self.BLIP_SIZE or 32
	self.BLIP_OFFSET_X = self.BLIP_OFFSET_X or -10
	self.BLIP_OFFSET_Y = self.BLIP_OFFSET_Y or -60
	self.BLIP_FADEOUT_SPEED = self.BLIP_FADEOUT_SPEED or 1
	self.BLIP_FADEIN_SPEED = self.BLIP_FADEIN_SPEED or 3

	self.BG_ON_COLOR = self.BG_ON_COLOR or "36545e"
	self._BG_ON_COLOR = Color(self.BG_ON_COLOR)
	self.BG_OFF_COLOR = self.BG_OFF_COLOR or "000000"
	self._BG_OFF_COLOR = Color(self.BG_OFF_COLOR)
	self.HOSTILE_COLOR = self.HOSTILE_COLOR or "ffffff" -- alternate "f4712b"
	self._HOSTILE_COLOR = Color(self.HOSTILE_COLOR)
	self.NEUTRAL_COLOR = self.NEUTRAL_COLOR or "ffffff"
	self._NEUTRAL_COLOR = Color(self.NEUTRAL_COLOR)
	self.FRIENDLY_COLOR = self.FRIENDLY_COLOR or "91edf2" -- alternate "e1f42b"
	self._FRIENDLY_COLOR = Color(self.FRIENDLY_COLOR)
	self.SCREEN_COLOR = self.SCREEN_COLOR or "6be6ed" --alternate vivid "91edf2"
	self._SCREEN_COLOR = Color(self.SCREEN_COLOR)
	self.JAMMED_COLOR = self.JAMMED_COLOR or "004a7f" --alternate "0060a4"
	self._JAMMED_COLOR = Color(self.JAMMED_COLOR) --windoze bg color
	self.JAMMED2_COLOR = self.JAMMED2_COLOR or "ffffff"
	self._JAMMED2_COLOR = Color(self.JAMMED2_COLOR) --jammed text
	
	
	--jammed stuff
	self.NUM_UPDATE_DOTS = self.NUM_UPDATE_DOTS or 6
	self.UPDATE_CIRCLE_RADIUS = self.UPDATE_CIRCLE_RADIUS or 50
	self.UPDATE_CIRCLE_OFFSET_X = self.UPDATE_CIRCLE_OFFSET_X or 0
	self.UPDATE_CIRCLE_OFFSET_Y = self.UPDATE_CIRCLE_OFFSET_Y or -50
	self.WINDOZE_LOGO_TEXTURE = self.WINDOZE_LOGO_TEXTURE or "units/mods/weapons/wpn_fps_upg_gadget_heartsensor/windoze10"
	
	self._delayedcall_id = tostring(unit:key()) .. "_hide_heartbeat_readout_screen"
	
	--it's the radar, sir! it appears to be.... JAMMED!
	self._current_jammed_phase = nil
	self.JAMMED_PHASE_DATA = {
		{ --bsod
			duration = 10,
			panel_data = {
				bluescreen_text_sad = true,
				bluescreen_text_error_medium = true,
				bluescreen_text_error_small = true,
				bluescreen_windoze_icon = true,
				bluescreen_text_update = false
			},
			bluescreen_dots = false,
			text_update = false
		},
		{ --update
			duration = 20,
			panel_data = {
				bluescreen_text_sad = false,
				bluescreen_text_error_medium = false,
				bluescreen_text_error_small = false,
				bluescreen_windoze_icon = false,
				bluescreen_text_update = true
			},
			bluescreen_dots = true,
			text_update = "Windoze is working on updates... %i%%\nThis could take a while.\nPlease don't turn off your gun."
		},
		{ --almost ready
			duration = 10,
			panel_data = {
				bluescreen_text_sad = false,
				bluescreen_text_error_medium = false,
				bluescreen_text_error_small = false,
				bluescreen_windoze_icon = false,
				bluescreen_text_update = true
			},
			bluescreen_dots = true,
			text_update = "Almost done... %i%%\nThis could take a while.\nPlease don't turn off your gun."
		},
		{ --almost ready (100)
			duration = 5,
			panel_data = {
				bluescreen_text_sad = false,
				bluescreen_text_error_medium = false,
				bluescreen_text_error_small = false,
				bluescreen_windoze_icon = false,
				bluescreen_text_update = true
			},
			bluescreen_dots = true,
			text_update = "Almost done... 100%%\nThis could take a while.\nPlease don't turn off your gun."
		},
		{ --almost ready (99)
			duration = 3,
			panel_data = {
				bluescreen_text_sad = false,
				bluescreen_text_error_medium = false,
				bluescreen_text_error_small = false,
				bluescreen_windoze_icon = false,
				bluescreen_text_update = true
			},
			bluescreen_dots = true,
			text_update = "Almost done... 99%%\nThis could take a while.\nPlease don't turn off your gun."
		},
		{ --almost ready (98)
			duration = 2,
			panel_data = {
				bluescreen_text_sad = false,
				bluescreen_text_error_medium = false,
				bluescreen_text_error_small = false,
				bluescreen_windoze_icon = false,
				bluescreen_text_update = true
			},
			bluescreen_dots = true,
			text_update = "Almost done... 98%%\nThis could take a while.\nPlease don't turn off your gun."
		},
		{ --almost ready (100) (real) (actually real)
			duration = 3,
			panel_data = {
				bluescreen_text_sad = false,
				bluescreen_text_error_medium = false,
				bluescreen_text_error_small = false,
				bluescreen_windoze_icon = false,
				bluescreen_text_update = true
			},
			bluescreen_dots = true,
			text_update = "Almost done... 100%%\nThis could take a while.\nPlease don't turn off your gun."
		},
		{ --your files are probably where we left them idk lol
			duration = 7,
			panel_data = {
				bluescreen_text_sad = false,
				bluescreen_text_error_medium = false,
				bluescreen_text_error_small = false,
				bluescreen_windoze_icon = false,
				bluescreen_text_update = true
			},
			bluescreen_dots = false,
			text_update = "Windoze has downgraded your gun.\nDid I say downgraded? I meant upgraded.\n\nAll your files are probably where you left them, idk lol"
		},
		[0] = { --setup
			duration = 0,
			panel_data = {
				bluescreen_text_sad = true,
				bluescreen_text_error_medium = true,
				bluescreen_text_error_small = true,
				bluescreen_windoze_icon = true,
				bluescreen_text_update = false
			},
			bluescreen_dots = false,
			text_update = false
		},
	}
	
	self:add_workspace(self._unit:get_object(Idstring(self._gui_object)))
	self:setup()
	
	self._heartbeat_targets = {}
	self._heartbeat_t = -self.SENSOR_SWEEP_INTERVAL --reset offset of t, prevents people from spamming the button to conserve battery, effectively resetting the "warmup time"

	self._unit:set_extension_update_enabled(Idstring("HeartbeatSensorGui"),true)
end

function HeartbeatSensorGui:add_workspace(gui_object)
	local onscreen_w = self.WORLD_WIDTH
	local onscreen_h = self.WORLD_HEIGHT
	local actual_w = self.PANEL_WIDTH
	local actual_h = self.PANEL_HEIGHT
	
	local ra = gui_object:rotation()
	local rb = Rotation(0,90,0)
	local rot = Rotation(ra:yaw() + rb:yaw(),ra:pitch() + rb:pitch(),ra:roll() + rb:roll())
	
	local x_axis = Vector3(onscreen_w,0,0)
	
	mvector3.rotate_with(x_axis,rot)
	
	local y_axis = Vector3(0,-onscreen_h,0) --these dang things are upside down for some reason
	
	mvector3.rotate_with(y_axis,rot)
	
	local center = Vector3(onscreen_w / 2,onscreen_h / 2,0)
	
	mvector3.rotate_with(center,rot)
	
	local offset = Vector3(-10.5,3,0.5)
	
	mvector3.rotate_with(offset,rot)
	
	local position = gui_object:position()
	
	self._ws = self._new_gui:create_world_workspace(actual_w,actual_h,position,x_axis,y_axis)
	
	self._ws:set_linked(actual_w,actual_h,gui_object,position - center + offset,x_axis,y_axis)
	
	self._panel = self._ws:panel():panel({
		name = "heartbeat_sensor_main_panel",
		layer = 1
	})
end

function HeartbeatSensorGui:setup()
	local bg_panel = self._panel:panel({
		name = "bg_panel",
		layer = -1,
		visible = false
	})
	self._bg_panel = bg_panel
	
	local readout_panel = self._panel:panel({
		name = "readout_panel",
		layer = 1,
		visible = self:is_on() or (not managers.groupai) --effectively allows the readout screen to be visible in blackmarket preview without having the attachment logic active
	})
	self._readout_panel = readout_panel
	
	self._readout_bg = readout_panel:rect({
		name = "readout_bg",
		color = self._BG_ON_COLOR,
		layer = -1
	})
	
	self._bg = bg_panel:rect({
		name = "heartbeat_bg",
		color = self._BG_OFF_COLOR,
		layer = -1,
		alpha = 1
	})
	self._overlay = readout_panel:bitmap({
		name = "overlay",
		texture = self.OVERLAY_TEXTURE,
		color = self._SCREEN_COLOR, 
		layer = 1,
		alpha = 0.5
	})
	
	self._scanlines_overlay = readout_panel:bitmap({
		name = "scanlines_overlay",
		texture = self.SCANLINES_TEXTURE,
		color = self._SCREEN_COLOR,
		w = self.PANEL_WIDTH,
		h = self.PANEL_HEIGHT * 2,
		alpha = 0.1,
		layer = 5,
		blend_mode = "subtract"
	})
	
	local constr_w = 0.8 * self._overlay:w() * readout_panel:h() / self._overlay:h()
	local constr_h = 0.8 * readout_panel:h()
	self._overlay:set_size(constr_w,constr_h)
	self._overlay:set_position((readout_panel:w() - self._overlay:w()) / 2,readout_panel:h() - self._overlay:h())
	
	self._range_indicator = readout_panel:text({
		name = "heartbeat_range_indicator",
		font = "fonts/font_eurostile_ext",
		font_size = 32,
		layer = 5,
		x = -90,
		y = -60,
		vertical = "bottom",
		align = "right",
		color = self._SCREEN_COLOR,
		text = string.format("%im",self.SENSOR_RANGE / 100)
	})
	
	self._battery_panel = self._panel:panel({
		name = "battery_panel",
		layer = 6
	})
	self._battery_fill = self._battery_panel:bitmap({
		name = "battery_fill",
		texture = self.BATTERY_FILL_TEXTURE,
		w = self.BATTERY_FILL_WIDTH * self.BATTERY_SCALE,
		h = self.BATTERY_FILL_HEIGHT * self.BATTERY_SCALE,
		x = self.BATTERY_X + (self.BATTERY_FILL_OFFSET_X * self.BATTERY_SCALE),
		y = self.BATTERY_Y + (self.BATTERY_FILL_OFFSET_Y * self.BATTERY_SCALE),
		color = self._BATTERY_COLOR,
		layer = 1,
		alpha = self.BATTERY_ALPHA
	})
	self._battery_frame = self._battery_panel:bitmap({
		name = "battery_frame",
		texture = self.BATTERY_FRAME_TEXTURE,
		w = self.BATTERY_FRAME_WIDTH * self.BATTERY_SCALE,
		h = self.BATTERY_FRAME_HEIGHT * self.BATTERY_SCALE,
		x = self.BATTERY_X,
		y = self.BATTERY_Y,
		color = self._BATTERY_COLOR,
		layer = 2,
		alpha = self.BATTERY_ALPHA
	})
	
	self._pulsewave = readout_panel:bitmap({
		name = "heartbeat_radial_wave",
		texture = self.PULSEWAVE_TEXTURE,
		w = 0,
		h = 0,
		layer = 3,
		color = self._SCREEN_COLOR,
		alpha = 0.25
	})
	self._pulsewave:set_center(self._panel:center())
	
	self._bluescreen_panel = self._panel:panel({
		name = "bluescreen_panel",
		layer = 5,
		visible = false
	})
	
	self._bluescreen_bg = self._bluescreen_panel:rect({
		name = "bluescreen_bg",
		layer = 1,
		color = self._JAMMED_COLOR
	})
	
	self._bluescreen_text_sad = self._bluescreen_panel:text({
		name = "bluescreen_text_sad",
		layer = 2,
		text = ":(",
		color = self._JAMMED2_COLOR,
		font = tweak_data.hud_players.ammo_font,
		x = 80,
		y = 100,
		font_size = 128,
		align = "left",
		visible = false
	})
	self._bluescreen_text_error_medium = self._bluescreen_panel:text({
		name = "bluescreen_text_error_medium",
		layer = 2,
		text = "Your gun ran into a problem and needs to\nrestart. We're just collecting some blood\nsamples, and then we'll restart for you.",
		color = self._JAMMED2_COLOR,
		font = tweak_data.hud_players.ammo_font,
		font_size = 24,
		align = "left",
		visible = false
	})
	local t_x,t_y,_,t_h =  self._bluescreen_text_sad:text_rect()
	self._bluescreen_text_error_medium:set_position(t_x,t_y + t_h + 16)
	t_x,t_y,_,t_h = self._bluescreen_text_error_medium:text_rect()
	self._bluescreen_text_error_small = self._bluescreen_panel:text({
		name = "bluescreen_text_error_small",
		layer = 2,
		text = "For more information about this easter egg, visit https://modworkshop.net/mod/28911.\n\nIf you screenshot this and post it to reddit, include the title:\n\"HI_REDDIT_I_FOUND_AN_EASTER_EGG_IN_A_MOD_AND_SOMEONE_TOLD_ME_TO_USE_THIS_AS_THE_TITLE\"",
		color = self._JAMMED2_COLOR,
		x = t_x,
		y = t_y + t_h + 16,
		font = tweak_data.hud_players.ammo_font,
		font_size = 12,
		align = "left",
		visible = false
	})
	self._bluescreen_windoze_icon = self._bluescreen_panel:bitmap({
		name = "bluescreen_windoze_icon",
		layer  = 2,
		texture = self.WINDOZE_LOGO_TEXTURE,
		color = self._JAMMED2_COLOR,
		w = 128,
		h = 128,
		x = 450,
		y = 180,
		visible = false
	})
	
	self._bluescreen_text_update = self._bluescreen_panel:text({
		name = "bluescreen_text_update",
		layer = 2,
		text = "Windoze is working on updates...\nThis could take a while.\nPlease don't turn off your gun.",
		color = self._JAMMED2_COLOR,
		font = tweak_data.hud_players.ammo_font,
		y = 100,
		font_size = 32,
		align = "center",
		vertical = "center",
		visible = false
	})

	for i=1,self.NUM_UPDATE_DOTS,1 do 
		local dot = self._bluescreen_panel:bitmap({
			name = "dot_" .. tostring(i),
			texture = self.BLIP_TEXTURE,
			w = 24,
			h = 24,
			color = self._JAMMED2_COLOR,
			layer = 2,
			visible = false
		})
	end
end

function HeartbeatSensorGui:_create_blip_bitmap(u_key,t_id,p)
	local blip_size = self.BLIP_SIZE
	local color = self._HOSTILE_COLOR
	if t_id == "criminal1" then
		color = self._FRIENDLY_COLOR
	elseif t_id == "neutral1" then 
		color = self._NEUTRAL_COLOR
	end
	local b = p:bitmap({
		name = u_key,
		texture = self.BLIP_TEXTURE,
		w = blip_size,
		h = blip_size,
		color = color,
		layer = 4,
		alpha = 0 --start 0,moved up gradually
	})
	return b
end

function HeartbeatSensorGui:_remove_blip_bitmap(u_key)
	local blip_data = self._heartbeat_targets[u_key]
	if blip_data and alive(blip_data.bitmap) then 
		blip_data.bitmap:parent():remove(blip_data.bitmap)
	end
	self._heartbeat_targets[u_key] = nil
end

function HeartbeatSensorGui:update(unit,t_raw,dt)
	if DelayedCallsFix then 
		--the ws may be linked to the unit but it doesn't currently have any built-in way of hiding if its parent unit is hidden
		--so just keep delaying the call to hide this panel, and when this extension's update() call stops occurring (when the parent unit is hidden), 
		--this delayed call will actually happen since it isn't being delayed anymore
		DelayedCallsFix:Add(self._delayedcall_id, 0.15, callback(self,self,"set_ws_visible",false))
		--don't even attempt using blt's DelayedCalls since it actually straight up doesn't work right here
	end
	
	if not self:is_on() then
		return
	end	
	
	if self._current_jammed_phase then 
		local jam_data = self._current_jammed_phase and self.JAMMED_PHASE_DATA[self._current_jammed_phase]
		if jam_data then 
			if self._heartbeat_t < jam_data.duration then
				local jammed_progress = 1 - ((jam_data.duration - self._heartbeat_t) / jam_data.duration)
				if jam_data.bluescreen_dots then 
					local c_x,c_y = self._bluescreen_panel:center()
					for i = 1,self.NUM_UPDATE_DOTS,1 do
						local dot = self._bluescreen_panel:child("dot_" .. tostring(i))
						if alive(dot) then 
							local j = (i / self.NUM_UPDATE_DOTS)
							local k = (t_raw + j) * math.pi * 2
							local x = math.cos(math.deg(k))
							local y = math.sin(math.deg(k))
							dot:set_position(self.UPDATE_CIRCLE_OFFSET_X + c_x + (self.UPDATE_CIRCLE_RADIUS * x),self.UPDATE_CIRCLE_OFFSET_Y + c_y + (self.UPDATE_CIRCLE_RADIUS * y))
						end
					end
				end
				if jam_data.text_update then 
					self._bluescreen_text_update:set_text(string.format(jam_data.text_update,100 * jammed_progress))
				end
				
				--specifically designed so that you must keep the sensor charged and the gun equipped during the bootup sequence
				self._heartbeat_t = self._heartbeat_t + dt
				return
			else 
				self._current_jammed_phase = self._current_jammed_phase + 1
				jam_data = self.JAMMED_PHASE_DATA[self._current_jammed_phase]
				if jam_data then 
					self._heartbeat_t = 0
					for name,state in pairs(jam_data.panel_data) do 
						local item = self._bluescreen_panel:child(name)
						if item then 
							item:set_visible(state)
						end
					end
					for i = 1,self.NUM_UPDATE_DOTS,1 do 
						local dot = self._bluescreen_panel:child("dot_" .. tostring(i))
						if alive(dot) then 
							dot:set_visible(jam_data.bluescreen_dots or false)
						end
					end
				end
				
				return
			end
		else --exit loop
			self._heartbeat_t = t_raw
			self._current_jammed_phase = nil
			self:check_screen()
		end
	end
	
	local SCANLINE_SPEED = 100
	self._scanlines_overlay:set_y(-((-t_raw * SCANLINE_SPEED) % self.PANEL_HEIGHT))
	
	local range = self.SENSOR_RANGE
	local sweep_margin = self.SENSOR_SWEEP_PERCENT * range
	local sweep_duration = self.SENSOR_SWEEP_DURATION
	local PAUSE_DURATION = sweep_duration * self.SENSOR_SWEEP_INTERVAL
	local total_duration = sweep_duration + PAUSE_DURATION
	local scale = self.READOUT_SCALE
	local panel = self._readout_panel
	
	local is_active
	
	local t = t_raw - self._heartbeat_t
	local user_unit = self._USER_UNIT
	if alive(unit) and alive(user_unit) and panel and alive(panel) then 
		local pos = user_unit:position()
		local _t = t % total_duration
		
		local t_pulsewave = (t + (PAUSE_DURATION * self.SENSOR_SWEEP_STAGGER)) % total_duration
		local pause_progress = math.pow(t_pulsewave / PAUSE_DURATION,3)
		
		self._pulsewave:set_size(self.PANEL_WIDTH * 2 * pause_progress,self.PANEL_WIDTH * 2 * pause_progress)
		self._pulsewave:set_center(panel:w() / 2,panel:h())
		
		if _t <= PAUSE_DURATION then
			--do nothing
		else
--			is_active = true
			local progress = (_t - PAUSE_DURATION) / sweep_duration
			
			--update list of applicable heartbeat sensor entities
			local all_units = World:find_units_quick("sphere",pos,range,self._SLOT_MASK) --ignore unit doesn't work i guess ,"ignore_unit",self._USER_UNIT)
			for _,target_unit in pairs(all_units) do 
				if (target_unit ~= self._USER_UNIT) and target_unit:movement() and target_unit:character_damage() then
				
					local u_pos = target_unit:movement():m_pos()
					local dis_to_target = mvector3.distance(Vector3(pos.x,pos.y,u_pos.z),u_pos)
					
					local team = target_unit:movement():team()
					local team_id = team and team.id
					local u_key = tostring(target_unit:key())
					
					if (dis_to_target > (progress * range) - sweep_margin) and (dis_to_target < (progress * range) + sweep_margin) then
						if not self._heartbeat_targets[u_key] then 
							self._heartbeat_targets[u_key] = {
								bitmap = self:_create_blip_bitmap(u_key,team_id,panel),
								unit = target_unit,
								team = team_id,
								distance = dis_to_target,
								last_t = t
							}
						else
							self._heartbeat_targets[u_key].team = team_id
							self._heartbeat_targets[u_key].last_t = t
							self._heartbeat_targets[u_key].distance = dis_to_target
						end
					--else don't update and let it decay
					end
				end
			end
		end
		
		for u_key,blip_data in pairs(self._heartbeat_targets) do 
			if alive(blip_data.unit) then 
				local removed
				local view_angle = unit:rotation():yaw()
				
				local dis_to_target
				local u_pos = blip_data.unit:movement():m_pos()
				local angle_to = 180 + view_angle - self.angle_from(Vector3(pos.x,pos.y,u_pos.z),u_pos)
				if is_active then
					dis_to_target = blip_data.distance
				else
					dis_to_target = mvector3.distance(Vector3(pos.x,pos.y,u_pos.z),u_pos)
				end
				
				if (blip_data.last_t <= t - sweep_duration) or (not blip_data.unit:character_damage() or blip_data.unit:character_damage():dead()) then 
					if blip_data.bitmap:alpha() <= 0 then 
						self:_remove_blip_bitmap(u_key,panel)
						removed = true
					else
						blip_data.bitmap:set_alpha(blip_data.bitmap:alpha() - (self.BLIP_FADEOUT_SPEED * dt))
					end
				else
					blip_data.bitmap:set_alpha(math.min(blip_data.bitmap:alpha() + (self.BLIP_FADEIN_SPEED * dt),1))
				end
				if not removed then 
					blip_data.bitmap:set_position(self.BLIP_OFFSET_X + (panel:w() / 2) + (scale * panel:h() * (dis_to_target / range) * math.cos(angle_to)),self.BLIP_OFFSET_Y + panel:h() + (scale * panel:h() * (dis_to_target / range) * math.sin(angle_to)))
				end
			else
				removed = true
				self:_remove_blip_bitmap(u_key,panel)
			end
		end
	end
end

function HeartbeatSensorGui:is_on()
	return self._on
end

function HeartbeatSensorGui:set_sensor_off()
	self._on = false
	for u_key,data in pairs(self._heartbeat_targets) do 
		self:_remove_blip_bitmap(u_key,self._readout_panel)
	end
	self:check_screen()
end

function HeartbeatSensorGui:set_sensor_on(skip_reset_t)
	self._on = true
	if not skip_reset_t then 
		if self._current_jammed_phase then 
			self._heartbeat_t = 0
		else
			self._heartbeat_t = Application:time()
		end
	end
	self:check_screen()
end

function HeartbeatSensorGui:check_screen() --sets the correct panels active according to current state data
	if self._on then 
		if self._current_jammed_phase then 
			self._bluescreen_panel:show()
			self._readout_panel:hide()
			self._bg_panel:hide()
		else
			self._readout_panel:show()
			self._bluescreen_panel:hide()
			self._bg_panel:hide()
		end
	else
		self._readout_panel:hide()
		self._bluescreen_panel:hide()
		self._bg_panel:show()
	end
end

function HeartbeatSensorGui:toggle_sensor(on,skip_reset_t)
	if on == nil then 
		on = not self._on
	end
	if on then 
		self:set_sensor_on(skip_reset_t)
	else
		self:set_sensor_off()
	end
end

function HeartbeatSensorGui:update_battery_level(level,t,dt)
	if self._battery_fill and self._battery_frame then 
		self._battery_fill:set_image(self.BATTERY_FILL_TEXTURE,0,0,level * self.BATTERY_FILL_WIDTH * self.BATTERY_SCALE,self.BATTERY_FILL_HEIGHT)
		self._battery_fill:set_width(level * self.BATTERY_FILL_WIDTH * self.BATTERY_SCALE)
		if level < 0.25 then 
			self._battery_fill:set_color(self._BATTERY_EMPTY_COLOR)
			self._battery_fill:set_alpha(math.max(math.ceil(math.sin(t * self.BATTERY_FLASH_SPEED)),0.1)) --flash between 0.1 and 1 alpha
		else
			self._battery_fill:set_alpha(self.BATTERY_ALPHA)
			self._battery_fill:set_color(self._BATTERY_COLOR)
		end
	end
end

function HeartbeatSensorGui:set_battery_visible(state)
	self._battery_panel:set_visible(state)
end

function HeartbeatSensorGui:set_jammed(state)
	if not state then
		self._readout_panel:show()
		self._bluescreen_panel:hide()
		self._current_jammed_phase = false
		self._heartbeat_t = Application:time()
	else --waits til ecm active time complete to progress
--	elseif not self._current_jammed_phase then --progresses during ecm active time
		self._current_jammed_phase = 0
		self._heartbeat_t = 0
		self._bluescreen_panel:show()
		self._readout_panel:hide()
	end
end

function HeartbeatSensorGui:set_ws_visible(state)
	if self._ws then 
		if state then 
			self._ws:show()
		else
			self._ws:hide()
		end
	end
end

function HeartbeatSensorGui:set_user_unit(unit)
	if not self._USER_UNIT then 
		self._USER_UNIT = unit
	end
end

function HeartbeatSensorGui:destroy()
	if alive(self._new_gui) and alive(self._ws) then
		self._new_gui:destroy_workspace(self._ws)

		self._ws = nil
		self._new_gui = nil
	end
end

